#pragma once

#include <errno.h>
#include <fcntl.h>
#include <inttypes.h>
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

// number of bytes to read from audio source x number of channels
// determins the size of all other buffers
// matches the CAVA_TREBLE_BUFFER_SIZE in core.h

#define BUFFER_SIZE 1024

struct audio_data {
    double *cava_in;

    int input_buffer_size;
    int cava_buffer_size;

    int format;
    unsigned int rate;
    unsigned int channels;
    char *source;  // alsa device, fifo path or pulse source
    int im;        // input mode alsa, fifo, pulse, portaudio, shmem or sndio
    int terminate; // shared variable used to terminate audio thread
    char error_message[1024];
    int samples_counter;
    pthread_mutex_t lock;
};

void reset_output_buffers(struct audio_data *data);

int write_to_cava_input_buffers(int16_t size, int16_t buf[size], void *data);

extern pthread_mutex_t lock;
